<?php
define("DBEXT", ".dbt");
define("INCEXT", ".inc");
define("LCKEXT", ".lock");
define('USER_COOKIE', 'adHocUser');         // Cookie User
define('USER_COOKIE_KEY', 'UserCookieKey'); // Nom de la variable dans le cookie contenant la clé
define('USER_SESSION', 'adHocUserSession'); // Nom de la session
$adHoc['version'] = "0.48";
$adHoc['date'] = "20160315";

// Equivalent à microtime(true) disponible depuis PHP 5.0.0.
function microtime_numerique ()
{
   list($usec, $sec) = explode(" ", microtime());
   return ((float)$usec + (float)$sec);
}
//
// Emulation de ctype_digit() si la bibliothèque ctype n'est pas installée.
// (compatibilité avec hébergeur iFrance)
//
if (! function_exists('ctype_digit')) {
  // bool ctype_digit ( string $text )
  function ctype_digit ($text)
  {
    return is_string($text) and preg_match('/\A\d+\z/', $text);
  }
}
//-----------------------------------------------------------------------------
// Conversion en HTML
//-----------------------------------------------------------------------------
// Convertit en HTML les sauts de lignes (\n et \r)
function conv_sauts_ligne ($chaine)
{
  // Convertit \n en <br /> et supprime \r - modif Kat 12 aout 2016<br> au lieu de </ br>
  return str_replace(array(chr(10), chr(13)), array("<br>", ""), $chaine);
}
// Remplace l'espace devant les signes : ! ? par un espace insécable &nbsp;
// pour éviter les sauts de lignes intempestifs.
function conv_ponctuation ($chaine)
{
  return preg_replace('/ ([:!?])/', '&nbsp;$1', $chaine);
}
// Convertit tous les caractères spéciaux en HTML avec htmlentities()
function conv_html ($chaine)
{
  $chaine = htmlentities($chaine, ENT_COMPAT, "UTF-8");
  // Correction des caractères Windows-1252 générés par Internet Explorer (!)
  // et non valides en HTML
  $table = array(
    "\x80" => '&euro;', "\x81" => '', "\x82" => '&sbquo;', "\x83" => '&fnof;',
    "\x84" => '&bdquo;', "\x85" => '&hellip;', "\x86" => '&dagger;', "\x87" => '&Dagger;',
    "\x88" => '&circ;', "\x89" => '&permil;', "\x8A" => '&Scaron;', "\x8B" => '&lsaquo;',
    "\x8C" => '&OElig;', "\x8D" => '', "\x8E" => '&#381;', "\x8F" => '',
    "\x90" => '', "\x91" => '&lsquo;', "\x92" => '&rsquo;', "\x93" => '&ldquo;',
    "\x94" => '&rdquo;', "\x95" => '&bull;', "\x96" => '&ndash;', "\x97" => '&mdash;',
    "\x98" => '&tilde;', "\x99" => '&trade;', "\x9A" => '&scaron;', "\x9B" => '&rsaquo;',
    "\x9C" => '&oelig;', "\x9D" => '', "\x9E" => '&#382;', "\x9F" => '&Yuml;'
  );
  $chaine = strtr($chaine, $table);
  // Conversion des entités HTML saisies dans le texte
  $chaine = preg_replace_callback(
    array('/&amp;([a-z]\w+);/i', '/&amp;#(\d{3,5});/'), "callback_entite_html", $chaine);
  return $chaine;
}
function callback_entite_html ($matches)
{
  if (ctype_digit($matches[1][0])) {
    // Entité numérique
    $num = (int) $matches[1];
    if ($num >= 160 and $num <= 65535) return '&#'.$num.';';
    else return $matches[0];
  }
  else {
    // Entité littérale
    if (in_array($matches[1], array( // Entités générées par Internet Explorer
      'acute', 'brvbar', 'cedil', 'curren',
      'frac12', 'frac14', 'frac34', 'uml'))) return '&'.$matches[1].';';
    else return $matches[0];
  }
}
// Convertit une URL en HTML
//
// - Encode, dans certaines parties de l'URL, les caractères non
//   alphanumériques (sauf -_.) sous la forme %hh, où h est un chiffre
//   hexadécimal (ex: espace -> %20, é -> %E9).
// - Encode les caractères spéciaux HTML restants avec conv_html()
// - Renvoie une chaine vide si l'URL n'est pas conforme
function conv_url ($url)
{
  return conv_html(encode_url_components($url));
}
// Note: ne pas appeler encode_url_components() directement.
// Pour un usage normal, il faut utiliser conv_url(). test Kat/Alex : ajouter protocoles tel et callto
function encode_url_components ($url, $default_scheme = 'http', $force_encode = true)
{
  $protocols = array("http", "https", "ftp", "mailto", "callto", "tel");
  if ($force_encode) {
    $func_urlencode = 'urlencode';
    $func_rawurlencode = 'rawurlencode';
  }
  else {
    $func_urlencode = 'urlencode_auto';
    $func_rawurlencode = 'rawurlencode_auto';
  }
  $url = trim($url);
  if ($url == '') return '';
  $comp = @parse_url($url);     // Décomposition de l'url
  if ($comp !== false) {
    if (isset($comp['scheme'])) $scheme = $comp['scheme'];
    else $scheme = trim($default_scheme);
    $scheme = strtolower($scheme);
    // Format de l'URL :
    // scheme://user:pass@host:port/path?query#fragment
    $result = '';
    if (isset($comp['scheme'])) {
      $comp['scheme'] = strtolower($comp['scheme']);
      if ($comp['scheme'] == 'mailto') $result .= $comp['scheme'].':';
	  if ($comp['scheme'] == 'callto') $result .= $comp['scheme'].':';
	  if ($comp['scheme'] == 'tel') $result .= $comp['scheme'].':';
      elseif (in_array($comp['scheme'], $protocols)) $result .= $comp['scheme'].'://';
      else return '';   // Refus des protocoles inconnus (sécurité)
    }
    if (isset($comp['user'])) {
      $result .= $func_rawurlencode($comp['user']);
      if (isset($comp['pass'])) $result .= ':'.$func_rawurlencode($comp['pass']);
      $result .= '@';
    }
    if (isset($comp['host'])) {
      $result .= $comp['host'];
      if (isset($comp['port'])) $result .= ':'.$comp['port'];
    }
    if (isset($comp['path'])) $result .= implode('/', array_map($func_rawurlencode, explode('/', $comp['path'])));
    if ($scheme == 'mailto') $func_encode = $func_rawurlencode;
	if ($scheme == 'callto') $func_encode = $func_rawurlencode;
	if ($scheme == 'tel') $func_encode = $func_rawurlencode;
    else $func_encode = $func_urlencode;
    if (isset($comp['query'])) {
      $arr = preg_split('/([&=])/', $comp['query'], -1, PREG_SPLIT_DELIM_CAPTURE);
      $result .= '?';
      foreach ($arr as $var) {
       if ($var == '&' || $var == '=') $result .= $var;
       else $result .= $func_encode($var);
      }
    }
    if (isset($comp['fragment'])) $result .= '#'.$func_encode($comp['fragment']);
    if ($result == '') $result = '#';
    return $result;
  }
  else return '';
}
function rawurlencode_auto ($url)
{
  // Encode les caractères spéciaux en %hh, où h est un chiffre hexa.
  // Si l'url contient déjà des caractères codés, ils sont décodés avant d'être ré-encodés
  return rawurlencode(rawurldecode($url));
}
function urlencode_auto ($url)
{
  // Encode les caractères spéciaux en %hh, où h est un chiffre hexa, ou en "+" pour l'espace.
  // Si l'url contient déjà des caractères codés, ils sont décodés avant d'être ré-encodés
  return urlencode(urldecode($url));
}

//-----------------------------------------------------------------------------
// Codage/décodage de chaine
//-----------------------------------------------------------------------------
// Décode une chaine ou un tableau issus d'un GET/POST/COOKIE (pouvant contenir des backslashes)
function decode_gpc ($argument)
{
  // Si l'option "magic_quotes_gpc" est active, PHP appelle automatiquement
  // addslashes sur les données renvoyées par GET/POST/COOKIES (ou GPC)
  // Il faut donc appeler stripslashes si cette option est active
  // et ne rien faire dans le cas contraire.
  if (is_array($argument)) {
    $tableau = array();
    foreach ($argument as $cle => $valeur) {
      $tableau[$cle] = decode_gpc(trim($valeur));
    }
    return $tableau;
  } else {
    if (get_magic_quotes_gpc()) return stripslashes(trim($argument));
    else return trim($argument);
  }
}

// Encode une valeur pour son écriture dans une chaine PHP entre guillemets simples (')
//
// Exemple:
//  $valeur = "une chaine avec 'guillemets simples'";
//  echo "\$var = '".encode_gpc($valeur)."';";
//
// affichera :
//
//  $var = 'une chaine avec \'guillemets simples\'';
function encode_gpc($string)
{
  // Protège les backslashes et les guillemets simples
  //return str_replace(array('\\', "'"), array('\\\\', "\\'"), $chaine);//deleted Penanders
  if (ini_get('magic_quotes_gpc')) return $string;
  else return addslashes($string);
}

//-----------------------------------------------------------------------------
// Fonctions diverses
//-----------------------------------------------------------------------------
// Renvoie le chemin de la racine du site
//
// Exemple:
//   Si l'URL du site est 'http://monsite.fr/' , site_path() retourne '/' .
//   Si l'URL du site est 'http://monsite.fr/site1/' , site_path() retourne '/site1/' .
function site_path ()
{
  // On suppose que ce script inclus est dans un sous-dossier de la racine du site (niveau 1)
  $root_path = dirname(dirname(__FILE__));
  if ($root_path == '/' or $root_path == '\\') $root_path = '';
  $working_path = getcwd();
  if ($working_path === false) return '/';
  if ($working_path == '/' or $working_path == '\\') $working_path = '';
  if (strlen($working_path) < strlen($root_path) or
      substr($working_path, 0, strlen($root_path)) != $root_path) return '/';
  $subpath = strtr(substr($working_path, strlen($root_path)), '\\', '/');
  $dir_level = substr_count($subpath, '/');
  $path = '';
  if (!empty($_SERVER['SCRIPT_URL'])) $path = $_SERVER['SCRIPT_URL'];
  elseif (!empty($_SERVER['SCRIPT_NAME'])) $path = $_SERVER['SCRIPT_NAME'];
  $i = strlen($path) - 1;
  while ($dir_level >= 0 and $i >= 0) {
    if ($path[$i] == '/') $dir_level--;
    $i--;
  }
  return encode_url_components(substr($path, 0, $i + 1).'/');
}

function path_link ($url) {
   if (strpos($url, "/") === false) $path = "/";
   else {
      $elements = explode ("/", $url);
      $path = "/".array_pop($elements)."/";
   }
   return $path;
}


// Lit les fichiers du compteur
function ReadCounter($file, $mode="w") {
   if (file_exists($file)) {
      $n = trim(file_get_contents($file));
   }
   if ($n === false) $n = 0;
   return $n;
}

// <=== Functions by Penanders

function GetDirList($workpath, $exclist=array()) { //List Directory
   $list = array();
   $handle = opendir($workpath);
   $exclist[] = ".";
   $exclist[] = "..";
   while (false !== ($entry = readdir($handle))) {
     if (is_dir($workpath.$entry) && (!in_array($entry,  $exclist))) {
         $list[] = $entry;
     }
   }
   closedir($handle);
   natcasesort($list);
   return $list;
}

function GetFilesByExt($workpath, $ext) { //List Files
   $list = array();
   if ($ext) {
      $types = explode (" ", strtolower($ext));
      $files = scandir($workpath);
      foreach ($files as $f) {
         if (is_file($workpath.$f) && in_array(GetFileExt($f),  $types)) $list[] = $f;
      }
   }
   return $list;
}

function GetFilesImg($workpath) {
   return GetFilesByExt($workpath, "jpg jpeg png gif");
}

function ReadCSVCols($filename = "", $delimiter = ";") {
   $header = null;
   $data = array();
   if (($handle = fopen($filename, 'r')) !== false)
   {
      while (($row = fgetcsv($handle, 1000, $delimiter)) !== false)
      {
         if (!$header)
            $header = $row;
         else
            $data[] = array_combine($header, $row);
      }
      fclose($handle);
   }
   return $data;
}

function ReadCSV ($filename = "", $enclosure = '"', $delimiter = ";") {
	$data = array();
	if (file_exists($filename) && ($handle = fopen($filename, 'r')) !== false) {
      while (($row = fgetcsv($handle, 1000, $delimiter)) !== false) {
         $data[] = $row;
      }
      fclose($handle);
   }
	return $data;
}

function WriteCSV($filename = "", $data, $enclosure = '"', $delimiter = ";") {
	$fp = fopen($filename, 'w');
	foreach ($data as $fields) {
	   if ($enclosure) fputcsv($fp, $fields, $delimiter, $enclosure);
      else fputcsv($fp, $fields, $delimiter);
	}
	fclose($fp);
}

function ReadCSVRows($filename = "", $enclosure = '"', $delimiter = ";") {
   $header = null;
   $data = array();
   if (($handle = fopen($filename, 'r')) !== false)
   {
      while (($row = fgetcsv($handle, 1000, $delimiter)) !== false)
      {
			$header = array_shift($row);
         $data[$header] = $row;
      }
      fclose($handle);
   }
   return $data;
}

function WriteCSVRows($filename = "", $data, $enclosure = '"', $delimiter = ";") {
	$fp = fopen($filename, 'w');
	foreach ($data as $key => $fields) {
	   array_unshift($fields, $key);
      if ($enclosure) fputcsv($fp, $fields, $delimiter, $enclosure);
	   else fputcsv($fp, $fields, $delimiter);
	}
   fclose($fp);
}

function ReadCSVPairs($filename = "", $enclosure = '"', $delimiter = ";") {
   $header = null;
   $data = array();
   if (($handle = fopen($filename, 'r')) !== false)
   {
      while (($row = fgetcsv($handle, 1000, $delimiter)) !== false)
      {
			$header = array_shift($row);
         $data[$header] = $row[0];
      }
      fclose($handle);
   }
   return $data;
}

function WriteCSVPairs($filename = "", $data, $enclosure = '"', $delimiter = ";") {
	$fp = fopen($filename, 'w');
	foreach ($data as $key => $value) {
	   $record = array($key, $value);
	   fputcsv($fp, $record, $delimiter, $enclosure);
	}
   fclose($fp);
}

function StartUserSession() {//function demarrer_session_admin ()
   // Force l'utilisation exclusive des cookies pour l'identifiant de session
   if (isset($_GET[USER_SESSION]) or isset($_POST[USER_SESSION])) return false;
   // Désactive l'écriture du SID dans les URL (si ini_set() fonctionne)
   if(session_id() === '') {
      @ini_set("session.use_trans_sid", "0");     // Nécessite PHP <= 4.2.3 ou PHP >= 5
      @ini_set("url_rewriter.tags", "");          // Solution de remplacement pour PHP 4.3/4.4
      // Autorise l'utilisation des cookies
      @ini_set("session.use_only_cookies", "1");
      @ini_set("session.use_cookies", "1");
      if (version_compare(PHP_VERSION, "5.2", ">=")) {
         session_set_cookie_params(0, SITE_PATH, NULL, 0, 1);
      } else {
         session_set_cookie_params(0, SITE_PATH, NULL, 0);
      }
      // Démarrage de la session
      session_name(USER_SESSION);
      session_start();
      // Désactive l'écriture du SID dans les URL (si ini_set() est désactivée)
      if (version_compare(PHP_VERSION, "4.3.0", ">=")) output_reset_rewrite_vars();
   }
   $result = (session_name() == USER_SESSION) ? true : false;
   return $result;
}



function GetUserLang($lg1, $lg2) {
	global $langs;
	if (in_array($lg1, $langs)) return $lg1;
	if (in_array($lg2, $langs)) return $lg2;
	$lg3 = substr($_SERVER['HTTP_ACCEPT_LANGUAGE'], 0, 2);
	if (in_array($lg3, $langs)) return $lg3;
	return $langs[0];
}
## Safe glob() replacement
## by BigueNique at yahoo dot ca
$tmp_glob = @glob(PATH.'index.php');
if (!is_array($tmp_glob)) {
   if (!function_exists('fnmatch')) {
      function fnmatch($pattern, $string) {
         return @preg_match('/^' . strtr(addcslashes($pattern, '\\.+^$(){}=!<>|'), array('*' => '.*', '?' => '.?')) . '$/i', $string);
      }
   }
   function safe_glob($pattern) {
      $split=explode('/',$pattern);
      $match=array_pop($split);
      $path=implode('/',$split);
      if (($dir=opendir($path))!==false) {
         $glob=array();
         while(($file=readdir($dir))!==false) {
            if (fnmatch($match,$file)) {
               if (is_file("$path/$file")) {
                  $glob[]=$path.'/'.$file;
               }
            }
         }
         closedir($dir);
         if (!($flags&GLOB_NOSORT)) sort($glob);
         return $glob;
      } else
      return false;
   }
} else {
   function safe_glob($pattern) {
      return glob($pattern);
   }
}
function ConvPath($text) {
   $out = preg_replace("/ (src|href)=('|\")(?!(http|mailto|callto|tel|ftp|#|javascript))/", " $1=$2".PATH_LNK, $text);
   return $out;
}
function StripPath($text) { // Delete PATH from links
   $host="http://".$_SERVER['HTTP_HOST'].PATH_LNK;
   $path=PATH_LNK;
   $out=preg_replace("! (src|href)=('|\")".$host."!", " $1=$2", $text);
   $out=preg_replace("! (src|href)=('|\")".PATH_LNK."!", " $1=$2", $out);
   return $out;
}

function FixUrl($url){
  $datain = array(
    "À", "Á", "Â", "Ã", "Ä", "Å", "Æ", "Ç", "È", "É", "Ê", "Ë", "Ì", "Í", "Î", "Ï",
    "Ð", "Ñ", "Ò", "Ó", "Ô", "Õ", "Ö", "Ø", "Ù", "Ú", "Û", "Ü", "Œ", " ", "'", ".",
    "à", "á", "â", "ã", "ä", "å", "æ", "ç", "è", "é", "ê", "ë", "ì", "í", "î", "ï",
    "ð", "ñ", "ò", "ó", "ô", "õ", "ö", "ø", "ù", "ú", "û", "ü", "ý", "œ", "&"
  );
  $dataout = array(
    "a", "a", "a", "a", "a", "a", "ae", "c", "e", "e", "e", "e", "i", "i", "i", "i",
    "o", "n", "o", "o", "o", "o", "o", "o", "u", "u", "u", "u", "oe", "-", "-", "_",
    "a", "a", "a", "a", "a", "a", "ae", "c", "e", "e", "e", "e", "i", "i", "i", "i",
    "o", "n", "o", "o", "o", "o", "o", "o", "u", "u", "u", "u", "y", "oe", "-and-"
  );
  $url = strtolower(str_replace($datain, $dataout, strip_tags($url)));
  $url = preg_replace('/[^[:alnum:]|_|-]+/','',$url);
  return mb_convert_encoding(preg_replace('/-+/', '-', $url),'ASCII');
}

function GetFileExt($file) {
    $pos = strrpos($file, '.');
    if($pos===false) {
        return false;
    } else {
        return strtolower(substr($file, $pos+1));
    }
}

function GetIsoDateTime() {
  $date = date("YmdHi");
  return $date;
}

function FormatDate ($date, $long=false) {
   if (!$long)
      return date(DATE_FORMAT, strtotime($date));
   else
      return date(DATE_FORMAT." ".TIME_FORMAT, strtotime($date));
}
function CheckUserNoBot() {
   $listrobots = array(
      "bingbot",
      "bot.",
      "bot/",
      "_bot",
      ".bot",
      "/bot",
      "-bot",
      ":bot",
      "crawl",
      "googlebot",
      "spider",
      "seek",
      "curl",
      "Jeeves",
      "yandex",
      "yahoo",
   );
   $robots = "#(".implode("|", $listrobots).")#i";
   if (preg_match($robots, USER_AGENT)) {
      // if (file_exists(PATH."data/robocheck".DBEXT)) $robotUA=ReadCSV(PATH_DAT."robocheck".DBEXT);
      // else $robotUA = array();
      // $robotUA[] = array(USER_AGENT, GetIsoDateTime());
      // WriteCSV(PATH_DAT."robocheck".DBEXT, $robotUA); //temp
      return false;
   }
   return true;
}

function WriteUserHitTime($filecounter, $hit_time = 120) {
   if (!USER_NOBOT) return false;
   $timedate = GetIsoDateTime();
   $diff = $hit_time." minutes ago";
   $past = date("YmdHi", strtotime($diff));
   $new = 1;
   $hits = array();
   if (file_exists($filecounter)) {
      $hits = ReadCSV($filecounter);
      $count = count($hits);
      for ($i = 0; $i<$count; $i++) {
         if ($hits[$i][0] == USER_IP) {
            if ($hits[$i][1] > $past) $new = 0;
            $hits[$i][1] = $timedate;
         } elseif($hits[$i][1] < $past) {
            unset($hits[$i]);
         }
      }
   }
   if ($new) $hits[] = array(USER_IP, $timedate);
   WriteCSV($filecounter, $hits);
   return $new;
}

function SelectRecordByField($Db, $NField, $content) {
   $DataDB = array();
   foreach ($Db as $rec) {
      if ($rec[$NField] == $content) {
         $DataDB[] = $rec;
      }
   }
   return $DataDB;
}
function GetRecnoByField($Db, $NField, $content) {
   $n = false;
   $count = count($Db);
   for ($i=0; $i<$count; $i++) {
      if ($Db[$i][$NField] == $content) {
         $n=$i;
         break;
      }
   }
   return $n;
}
function MailVerify($mail) {
   return (preg_match('/^[\w-]+(\.[\w-]+)*@([\w-]+\.)+[a-zA-Z]{2,6}$/', $mail));
}
function UserNameVerify($name) {
   //return (preg_match('/^[\p{L}0-9_ ]{4,12}$/u', $name)); //no
   //return (preg_match('/(*UTF8)^[\p{L}0-9_\s]{4,12}$', $name)); // spazi
   return (preg_match('/(*UTF8)^[\p{L}0-9_]{4,12}$/', $name));
}
function DisplaySelect($name, $values, $texts, $selected, $class=""){
   if (empty($selected)) $selected = $values[0];
   echo '<select'; 
   if ($class) echo ' class="'.$class.'"';
   echo ' name="'.$name."\">\n";
   $i=0;
   foreach ($values as $v) {
      echo '<option value="'.$v.'"';
      if ($v==$selected) echo " selected";
      echo ">".$texts[$i]."</option>\n";
      $i++;
   }
   echo "</select>\n";
}
?>
